/*****************************************************************************
Original version of mpeg2encode is copyrighted to:
MPEG Software Simulation Group. All Rights Reserved.

Disclaimer of Warranty

mpeg2encode is available to the user without any license fee or
royalty on an "as is" basis.  The MPEG Software Simulation Group disclaims
any and all warranties, whether express, implied, or statuary, including any
implied warranties or merchantability or of fitness for a particular
purpose.  In no event shall the copyright-holder be liable for any
incidental, punitive, or consequential damages of any kind whatsoever
arising from the use of these programs.

This disclaimer of warranty extends to the user of these programs and user's
customers, employees, agents, transferees, successors, and assigns.

The MPEG Software Simulation Group does not represent or warrant that the
programs furnished hereunder are free of infringement of any third-party
patents.

Commercial implementations of MPEG-1 and MPEG-2 video, including shareware,
are subject to royalty fees to patent holders.  Many of these patents are
general enough such that they are unavoidable regardless of implementation
design.


Modification of mpeg2encode contained in PM2V source code is copyrighted by 
Jean Laurent and Olivier Guillot.
This modification are distributed under the GPL (GNU Public License). 
see license.txt in the doc directory for details.

You can contact us to pm2v@free.fr or pm2v@sourceforge.net
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include  "fdctref.h"
#include  "idct.h"
#include  "motion.h"
#include  "mpeg2enc.h"
#include  "params.h"
#include  "predict.h"
#include  "putbits.h"
#include  "puthdr.h"
#include  "putmpg.h"
#include  "putpic.h"
#include  "putseq.h"
#include  "putvlc.h"
#include  "quantize.h"
#include  "ratectl.h"
#include  "readpic.h"
#include  "stats.h"
#include  "transfrm.h"
#include  "writepic.h"


void 
loadparam (char *param)
     char *fname;
{
  int i;
  int h, m, s, f;
  char *paramptr;
  FILE *fd;
  char line[256];
  static double ratetab[8] =
  {24000.0 / 1001.0, 24.0, 25.0, 30000.0 / 1001.0, 30.0, 50.0, 60000.0 / 1001.0, 60.0};
  extern int r, Xi, Xb, Xp, d0i, d0p, d0b;	/* rate control */
  extern double avg_act;	/* rate control */

  paramptr = param;


  assert (parseparam (char *param));


  /*
     if (param==NULL)
     {
     sprintf(errortext,"Couldn't open parameter file %s",fname);
     error(errortext);
     } */

  //sscanf(paramptr,
  // for (;*paramptr!='/n';paramptr++);

  /*
     fgets(id_string,254,fd);
     fgets(line,254,fd); sscanf(line,"%s",tplorg);
     fgets(line,254,fd); sscanf(line,"%s",tplref);
     fgets(line,254,fd); sscanf(line,"%s",iqname);
     fgets(line,254,fd); sscanf(line,"%s",niqname);
     fgets(line,254,fd); sscanf(line,"%s",statname);
     fgets(line,254,fd); sscanf(line,"%d",&inputtype);
     fgets(line,254,fd); sscanf(line,"%d",&nframes);
     fgets(line,254,fd); sscanf(line,"%d",&frame0);
     fgets(line,254,fd); sscanf(line,"%d:%d:%d:%d",&h,&m,&s,&f);
     fgets(line,254,fd); sscanf(line,"%d",&N);
     fgets(line,254,fd); sscanf(line,"%d",&M);
     fgets(line,254,fd); sscanf(line,"%d",&mpeg1);
     fgets(line,254,fd); sscanf(line,"%d",&fieldpic);
     fgets(line,254,fd); sscanf(line,"%d",&horizontal_size);
     fgets(line,254,fd); sscanf(line,"%d",&vertical_size);
     fgets(line,254,fd); sscanf(line,"%d",&aspectratio);
     fgets(line,254,fd); sscanf(line,"%d",&frame_rate_code);
     fgets(line,254,fd); sscanf(line,"%lf",&bit_rate);
     fgets(line,254,fd); sscanf(line,"%d",&vbv_buffer_size);   
     fgets(line,254,fd); sscanf(line,"%d",&low_delay);     
     fgets(line,254,fd); sscanf(line,"%d",&constrparms);
     fgets(line,254,fd); sscanf(line,"%d",&profile);
     fgets(line,254,fd); sscanf(line,"%d",&level);
     fgets(line,254,fd); sscanf(line,"%d",&prog_seq);
     fgets(line,254,fd); sscanf(line,"%d",&chroma_format);
     fgets(line,254,fd); sscanf(line,"%d",&video_format);
     fgets(line,254,fd); sscanf(line,"%d",&color_primaries);
     fgets(line,254,fd); sscanf(line,"%d",&transfer_characteristics);
     fgets(line,254,fd); sscanf(line,"%d",&matrix_coefficients);
     fgets(line,254,fd); sscanf(line,"%d",&display_horizontal_size);
     fgets(line,254,fd); sscanf(line,"%d",&display_vertical_size);
     fgets(line,254,fd); sscanf(line,"%d",&dc_prec);
     fgets(line,254,fd); sscanf(line,"%d",&topfirst);
     fgets(line,254,fd); sscanf(line,"%d %d %d",
     frame_pred_dct_tab,frame_pred_dct_tab+1,frame_pred_dct_tab+2);

     fgets(line,254,fd); sscanf(line,"%d %d %d",
     conceal_tab,conceal_tab+1,conceal_tab+2);

     fgets(line,254,fd); sscanf(line,"%d %d %d",
     qscale_tab,qscale_tab+1,qscale_tab+2);

     fgets(line,254,fd); sscanf(line,"%d %d %d",
     intravlc_tab,intravlc_tab+1,intravlc_tab+2);
     fgets(line,254,fd); sscanf(line,"%d %d %d",
     altscan_tab,altscan_tab+1,altscan_tab+2);
     fgets(line,254,fd); sscanf(line,"%d",&repeatfirst);
     fgets(line,254,fd); sscanf(line,"%d",&prog_frame);
     // intra slice interval refresh period   
     fgets(line,254,fd); sscanf(line,"%d",&P);
     fgets(line,254,fd); sscanf(line,"%d",&r);
     fgets(line,254,fd); sscanf(line,"%lf",&avg_act);
     fgets(line,254,fd); sscanf(line,"%d",&Xi);
     fgets(line,254,fd); sscanf(line,"%d",&Xp);
     fgets(line,254,fd); sscanf(line,"%d",&Xb);
     fgets(line,254,fd); sscanf(line,"%d",&d0i);
     fgets(line,254,fd); sscanf(line,"%d",&d0p);
     fgets(line,254,fd); sscanf(line,"%d",&d0b);
   */

  if (N < 1)
    error ("N must be positive");
  if (M < 1)
    error ("M must be positive");
  if (N % M != 0)
    error ("N must be an integer multiple of M");

  motion_data = (struct motion_data *) malloc (M * sizeof (struct motion_data));
  if (!motion_data)
    error ("malloc failed\n");

  for (i = 0; i < M; i++)
    {
      fgets (line, 254, fd);
      sscanf (line, "%d %d %d %d",
	  &motion_data[i].forw_hor_f_code, &motion_data[i].forw_vert_f_code,
	      &motion_data[i].sxf, &motion_data[i].syf);

      if (i != 0)
	{
	  fgets (line, 254, fd);
	  sscanf (line, "%d %d %d %d",
	  &motion_data[i].back_hor_f_code, &motion_data[i].back_vert_f_code,
		  &motion_data[i].sxb, &motion_data[i].syb);
	}
    }

  fclose (fd);

  /* make flags boolean (x!=0 -> x=1) */
  mpeg1 = !!mpeg1;
  fieldpic = !!fieldpic;
  low_delay = !!low_delay;
  constrparms = !!constrparms;
  prog_seq = !!prog_seq;
  topfirst = !!topfirst;

  for (i = 0; i < 3; i++)
    {
      frame_pred_dct_tab[i] = !!frame_pred_dct_tab[i];
      conceal_tab[i] = !!conceal_tab[i];
      qscale_tab[i] = !!qscale_tab[i];
      intravlc_tab[i] = !!intravlc_tab[i];
      altscan_tab[i] = !!altscan_tab[i];
    }
  repeatfirst = !!repeatfirst;
  prog_frame = !!prog_frame;

  /* make sure MPEG specific parameters are valid */
  range_checks ();

  frame_rate = ratetab[frame_rate_code - 1];

  /* timecode -> frame number */
  tc0 = h;
  tc0 = 60 * tc0 + m;
  tc0 = 60 * tc0 + s;
  tc0 = (int) (frame_rate + 0.5) * tc0 + f;

  if (!mpeg1)
    {
      profile_and_level_checks ();
    }
  else
    {
      /* MPEG-1 */
      if (constrparms)
	{
	  if (horizontal_size > 768
	      || vertical_size > 576
	      || ((horizontal_size + 15) / 16) * ((vertical_size + 15) / 16) > 396
	      || ((horizontal_size + 15) / 16) * ((vertical_size + 15) / 16) * frame_rate > 396 * 25.0
	      || frame_rate > 30.0)
	    {
	      if (!quiet)
		fprintf (stderr, "Warning: setting constrained_parameters_flag = 0\n");
	      constrparms = 0;
	    }
	}

      if (constrparms)
	{
	  for (i = 0; i < M; i++)
	    {
	      if (motion_data[i].forw_hor_f_code > 4)
		{
		  if (!quiet)
		    fprintf (stderr, "Warning: setting constrained_parameters_flag = 0\n");
		  constrparms = 0;
		  break;
		}

	      if (motion_data[i].forw_vert_f_code > 4)
		{
		  if (!quiet)
		    fprintf (stderr, "Warning: setting constrained_parameters_flag = 0\n");
		  constrparms = 0;
		  break;
		}

	      if (i != 0)
		{
		  if (motion_data[i].back_hor_f_code > 4)
		    {
		      if (!quiet)
			fprintf (stderr, "Warning: setting constrained_parameters_flag = 0\n");
		      constrparms = 0;
		      break;
		    }

		  if (motion_data[i].back_vert_f_code > 4)
		    {
		      if (!quiet)
			fprintf (stderr, "Warning: setting constrained_parameters_flag = 0\n");
		      constrparms = 0;
		      break;
		    }
		}
	    }
	}
    }

  /* relational checks */

  if (mpeg1)
    {
      if (!prog_seq)
	{
	  if (!quiet)
	    fprintf (stderr, "Warning: setting progressive_sequence = 1\n");
	  prog_seq = 1;
	}

      if (chroma_format != CHROMA420)
	{
	  if (!quiet)
	    fprintf (stderr, "Warning: setting chroma_format = 1 (4:2:0)\n");
	  chroma_format = CHROMA420;
	}

      if (dc_prec != 0)
	{
	  if (!quiet)
	    fprintf (stderr, "Warning: setting intra_dc_precision = 0\n");
	  dc_prec = 0;
	}

      for (i = 0; i < 3; i++)
	if (qscale_tab[i])
	  {
	    if (!quiet)
	      fprintf (stderr, "Warning: setting qscale_tab[%d] = 0\n", i);
	    qscale_tab[i] = 0;
	  }

      for (i = 0; i < 3; i++)
	if (intravlc_tab[i])
	  {
	    if (!quiet)
	      fprintf (stderr, "Warning: setting intravlc_tab[%d] = 0\n", i);
	    intravlc_tab[i] = 0;
	  }

      for (i = 0; i < 3; i++)
	if (altscan_tab[i])
	  {
	    if (!quiet)
	      fprintf (stderr, "Warning: setting altscan_tab[%d] = 0\n", i);
	    altscan_tab[i] = 0;
	  }
    }

  if (!mpeg1 && constrparms)
    {
      if (!quiet)
	fprintf (stderr, "Warning: setting constrained_parameters_flag = 0\n");
      constrparms = 0;
    }

  if (prog_seq && !prog_frame)
    {
      if (!quiet)
	fprintf (stderr, "Warning: setting progressive_frame = 1\n");
      prog_frame = 1;
    }

  if (prog_frame && fieldpic)
    {
      if (!quiet)
	fprintf (stderr, "Warning: setting field_pictures = 0\n");
      fieldpic = 0;
    }

  if (!prog_frame && repeatfirst)
    {
      if (!quiet)
	fprintf (stderr, "Warning: setting repeat_first_field = 0\n");
      repeatfirst = 0;
    }

  if (prog_frame)
    {
      for (i = 0; i < 3; i++)
	if (!frame_pred_dct_tab[i])
	  {
	    if (!quiet)
	      fprintf (stderr, "Warning: setting frame_pred_frame_dct[%d] = 1\n", i);
	    frame_pred_dct_tab[i] = 1;
	  }
    }

  if (prog_seq && !repeatfirst && topfirst)
    {
      if (!quiet)
	fprintf (stderr, "Warning: setting top_field_first = 0\n");
      topfirst = 0;
    }

  /* search windows */
  for (i = 0; i < M; i++)
    {
      if (motion_data[i].sxf > (4 << motion_data[i].forw_hor_f_code) - 1)
	{
	  if (!quiet)
	    fprintf (stderr,
		"Warning: reducing forward horizontal search width to %d\n",
		     (4 << motion_data[i].forw_hor_f_code) - 1);
	  motion_data[i].sxf = (4 << motion_data[i].forw_hor_f_code) - 1;
	}

      if (motion_data[i].syf > (4 << motion_data[i].forw_vert_f_code) - 1)
	{
	  if (!quiet)
	    fprintf (stderr,
		  "Warning: reducing forward vertical search width to %d\n",
		     (4 << motion_data[i].forw_vert_f_code) - 1);
	  motion_data[i].syf = (4 << motion_data[i].forw_vert_f_code) - 1;
	}

      if (i != 0)
	{
	  if (motion_data[i].sxb > (4 << motion_data[i].back_hor_f_code) - 1)
	    {
	      if (!quiet)
		fprintf (stderr,
		"Warning: reducing backward horizontal search width to %d\n",
			 (4 << motion_data[i].back_hor_f_code) - 1);
	      motion_data[i].sxb = (4 << motion_data[i].back_hor_f_code) - 1;
	    }

	  if (motion_data[i].syb > (4 << motion_data[i].back_vert_f_code) - 1)
	    {
	      if (!quiet)
		fprintf (stderr,
		 "Warning: reducing backward vertical search width to %d\n",
			 (4 << motion_data[i].back_vert_f_code) - 1);
	      motion_data[i].syb = (4 << motion_data[i].back_vert_f_code) - 1;
	    }
	}
    }

}
