/*****************************************************************************
Original version of mpeg2encode is copyrighted to:
MPEG Software Simulation Group. All Rights Reserved.

Disclaimer of Warranty

mpeg2encode is available to the user without any license fee or
royalty on an "as is" basis.  The MPEG Software Simulation Group disclaims
any and all warranties, whether express, implied, or statuary, including any
implied warranties or merchantability or of fitness for a particular
purpose.  In no event shall the copyright-holder be liable for any
incidental, punitive, or consequential damages of any kind whatsoever
arising from the use of these programs.

This disclaimer of warranty extends to the user of these programs and user's
customers, employees, agents, transferees, successors, and assigns.

The MPEG Software Simulation Group does not represent or warrant that the
programs furnished hereunder are free of infringement of any third-party
patents.

Commercial implementations of MPEG-1 and MPEG-2 video, including shareware,
are subject to royalty fees to patent holders.  Many of these patents are
general enough such that they are unavoidable regardless of implementation
design.


Modification of mpeg2encode contained in PM2V source code is copyrighted by 
Jean Laurent and Olivier Guillot.
This modification are distributed under the GPL (GNU Public License). 
see license.txt in the doc directory for details.

You can contact us to pm2v@free.fr or pm2v@sourceforge.net
*****************************************************************************/

#include  "fdctref.h"
#include  "idct.h"
#include  "motion.h"
#include  "mpeg2enc.h"
#include  "params.h"
#include  "predict.h"
#include  "putbits.h"
#include  "puthdr.h"
#include  "putmpg.h"
#include  "putpic.h"
#include  "putseq.h"
#include  "putvlc.h"
#include  "quantize.h"
#include  "ratectl.h"
#include  "readpic.h"
#include  "stats.h"
#include  "transfrm.h"
#include  "writepic.h"
#include <stdio.h>
#include "config.h"

//extern FILE *output; /* the only global var we need here */

/* private data */
static unsigned char outbfr;
static int outcnt;
static int bytecnt;

static unsigned char pm2v_outbfr;
static int pm2v_outcnt;
static int pm2v_bytecnt;

/* initialize buffer, call once before first putbits or alignbits */
void 
initbits ()
{
  outcnt = 8;
  bytecnt = 0;
}

/* write rightmost n (0<=n<=32) bits of val to outfile */
void 
putbits (pm2v_stream * stream, int val, int n)
{
  int i;
  unsigned int mask;

  mask = 1 << (n - 1);		/* selects first (leftmost) bit */

  for (i = 0; i < n; i++)
    {
      outbfr <<= 1;

      if (val & mask)
	outbfr |= 1;

      mask >>= 1;		/* select next bit */
      outcnt--;

      if (outcnt == 0)		/* 8 bit buffer full */
	{
	  putc (outbfr, stream->param.output);
	  outcnt = 8;
	  bytecnt++;
	}
    }
}

/* zero bit stuffing to next byte boundary (5.2.3, 6.2.1) */
void 
alignbits (pm2v_stream * stream)
{
  if (outcnt != 8)
    putbits (stream, 0, outcnt);
}

/* return total number of generated bits */
int 
bitcount ()
{
  return 8 * bytecnt + (8 - outcnt);
}


/*
   void pm2v_putbits(pm2v_stream * stream,int val, int n)
   {
   int i;
   unsigned int mask;

   mask = 1 << (n-1);

   for (i=0; i<n; i++)
   {
   pm2v_outbfr <<= 1;

   if (val & mask)
   pm2v_outbfr|= 1;

   mask >>= 1;
   pm2v_outcnt--;

   if (pm2v_outcnt==0)
   {
   pm2v_bits_buffer[pm2v_bits_count>>8]=outbfr;
   putc(outbfr,stream->param.output);
   pm2v_outcnt = 8;
   }
   pm2v_bits_count++;
   }
   }

 */
