/*****************************************************************************
Original version of mpeg2encode is copyrighted to:
MPEG Software Simulation Group. All Rights Reserved.

Disclaimer of Warranty

mpeg2encode is available to the user without any license fee or
royalty on an "as is" basis.  The MPEG Software Simulation Group disclaims
any and all warranties, whether express, implied, or statuary, including any
implied warranties or merchantability or of fitness for a particular
purpose.  In no event shall the copyright-holder be liable for any
incidental, punitive, or consequential damages of any kind whatsoever
arising from the use of these programs.

This disclaimer of warranty extends to the user of these programs and user's
customers, employees, agents, transferees, successors, and assigns.

The MPEG Software Simulation Group does not represent or warrant that the
programs furnished hereunder are free of infringement of any third-party
patents.

Commercial implementations of MPEG-1 and MPEG-2 video, including shareware,
are subject to royalty fees to patent holders.  Many of these patents are
general enough such that they are unavoidable regardless of implementation
design.


Modification of mpeg2encode contained in PM2V source code is copyrighted by 
Jean Laurent and Olivier Guillot.
This modification are distributed under the GPL (GNU Public License). 
see license.txt in the doc directory for details.

You can contact us to pm2v@free.fr or pm2v@sourceforge.net
*****************************************************************************/

#include  "fdctref.h" 
#include  "idct.h" 
#include  "motion.h" 
#include  "mpeg2enc.h" 
#include  "params.h" 
#include  "predict.h" 
#include  "putbits.h" 
#include  "puthdr.h" 
#include  "putmpg.h" 
#include  "putpic.h" 
#include  "putseq.h" 
#include  "putvlc.h" 
#include  "quantize.h" 
#include  "ratectl.h" 
#include  "readpic.h" 
#include  "stats.h" 
#include  "transfrm.h"
#include  "writepic.h" 
#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "quant.h"

void writeframe(stream,fname,frame)
     pm2v_stream* stream;
char *fname;
unsigned char *frame[];
{
  int chrom_hsize, chrom_vsize;
  char name[128];
  FILE *fd;

  chrom_hsize = (stream->param.chroma_format==CHROMA444) ? stream->param.horizontal_size
                                           : stream->param.horizontal_size>>1;

  chrom_vsize = (stream->param.chroma_format!=CHROMA420) ? stream->param.vertical_size
                                           : stream->param.vertical_size>>1;

  if (fname[0]=='-')
    return;

  /* Y */
  sprintf(name,"%s.Y",fname);
  if (!(fd = fopen(name,"wb")))
  {
    //sprintf(errortext,"Couldn't create %s\n",name);
    //error(errortext);
  }
  fwrite(frame[0],1,stream->param.horizontal_size*stream->param.vertical_size,fd);
  fclose(fd);

  /* Cb */
  sprintf(name,"%s.U",fname);
  if (!(fd = fopen(name,"wb")))
  {
    //sprintf(errortext,"Couldn't create %s\n",name);
    //error(errortext);
  }
  fwrite(frame[1],1,chrom_hsize*chrom_vsize,fd);
  fclose(fd);

  /* Cr */
  sprintf(name,"%s.V",fname);
  if (!(fd = fopen(name,"wb")))
  {
    //sprintf(errortext,"Couldn't create %s\n",name);
    //error(errortext);
  }
  fwrite(frame[2],1,chrom_hsize*chrom_vsize,fd);
  fclose(fd);
}
